package DinnerParty;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;

/* This is actually a very strange applet.... It really never displays anything.
 * In fact, it is designed to run in a 1x1 area.  It is primarily an interface
 * between the mail Dinner Party class, and the Javascript running in the brower.
 * That arrangement solves a few problems that a stand alone applet might have.
 * 1) It will run in IE without the Java Plugin.
 * 2) I don't have to worry about parsing or displaying HTML.  So, the story
 *    designer can format it almost any way they want, and I can still do the
 *    variable substitution.
*/
public class DinnerPartyApplet extends Applet {
  private URL filesURL;
  private String stories;
  private String datapath;
  private Frame theFrame;
  private DinnerParty theParty;

  //Get a parameter value

  public String getParameter(String key, String def) {
    return (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet

  public DinnerPartyApplet() {
  }
//Initialize the applet

  public void init() {

    //Get the parameters with the datapath and initial control file
    try { stories = this.getParameter("stories", ""); } catch (Exception e) { e.printStackTrace(); }
    try { datapath = this.getParameter("datapath", "Stories/"); } catch (Exception e) { e.printStackTrace(); }
    try {
      filesURL = new URL(this.getCodeBase(),datapath);
      System.out.println("Files Path="+filesURL+stories);
    }
    catch (MalformedURLException e) {e.printStackTrace();}
    theParty = new DinnerParty(filesURL, stories);
		// Hack from Symantec BBS to get Frame of an applet
		Container cContainer = (Container) this;
		Container aParent = this.getParent();
		while (!(aParent instanceof Frame)) {
 	      	aParent = aParent.getParent();
		}
		theFrame = (Frame) aParent;
		theFrame.setTitle("Dinner Party V2.0");
  }
//Component initialization

//Start the applet

  public void start() {
  }
//Stop the applet

  public void stop() {
  }
//Destroy the applet

  public void destroy() {
  }
//Get Applet information
  
  public String getAppletInfo() {
    return "<b>Dinner Party V2.0</b><br>(c) 2003 Vrtisworks";
  }
//Get parameter info
  
  public String[][] getParameterInfo() {
    String pinfo[][] =
    {
      {"stories", "String", "File with list of Stories available."},
      {"datapath", "String", "Subdirectory for the stories files."},
    };
    return pinfo;
  }
  //Convert \n to <br> so that it displays better in HTML
  private String nl2br(String s) {
    int i;
    int e;

    StringBuffer brstring = new StringBuffer(s.length());
    i=0;
    while (i<s.length()) {
      e=s.indexOf('\n',i);
      if (e==-1) {
        e=s.length();
      }
      brstring.append(s.substring(i,e));
      brstring.append("<br>\n");
      i = ++e;
    }
    return brstring.toString();
  }

  //Calls DinnerParty to load the stories available, then creates SELECT HTML with
  //the names of the stories available.
  public String loadStories(String attributes) {
    StringBuffer select = new StringBuffer(100);
    select.append("<SELECT ");
    select.append(attributes);
    select.append("><OPTION SELECTED='1' value='-1'>Pick a Story</OPTION>");
    int cnt = theParty.loadStories();
    for (int i=0; i<cnt; i++) {
      select.append("<OPTION VALUE='"+i+"'>"+theParty.getStoryTitle(i)+"</OPTION>");
    }
    select.append("</SELECT>");
    //System.out.println(select.toString());
    return select.toString();
  }
  public String getStoryTitle(int s) {
    return theParty.getStoryTitle(s);
  }
  //Convert the \n's in the about to <br> so it displays a little better.
  public String getStoryAbout(int s) {
    return nl2br(theParty.getStoryAbout(s));
  }
  public void loadStoryList(int s) {
    theParty.loadStoryList(s);
  }
  public String getVariableSelect(String attributes) {
    String vn;
    int i;

    int nv = theParty.getVariableCount(); //Get the number of variables.
    if (nv<20) {  //Set the number of rows in the select. 20 is max.
      i=nv;
    } else {
      i=20;       //Probably should make this a PARAM someday....
    }
    StringBuffer select = new StringBuffer(100);
    select.append("<SELECT ");
    select.append(attributes);
    select.append(">\n");
    for (i=0; i<nv; i++) {
      select.append("<OPTION VALUE='");
      select.append(i);
      select.append("'>");
      select.append(theParty.getVariableName(i));
      select.append("</OPTION>\n");
    }
    select.append("</SELECT>\n");
    //System.out.println(select.toString());
    return select.toString();
  }
  public int getVariableCount() {
    return theParty.getVariableCount();
  }
  public String getVariableType(int v) {
    return theParty.getVariableType(v);
  }
  public String getVariableHelp(int v) {
    return theParty.getVariableHelp(v);
  }
  public String getVariableChoice(int v, int s, String attributes) {
    String [] choices = theParty.getVariableChoice(v);
    StringBuffer select = new StringBuffer(100);
    select.append("<SELECT ");
    select.append(attributes);
    select.append(">\n");
    if (s==-1) {  //So that there will be a change..default is 1st on selected
      select.append("<OPTION VALUE='-1' SELECTED='1'>Choose</OPTION>\n");
    }
    for (int i=0; i<choices.length; i++) {
      select.append("<OPTION VALUE='");
      select.append(i);
      if (i==s) {
        select.append("' SELECTED='1'>");
      } else {
        select.append("'>");
      }
      select.append(choices[i]);
      select.append("</OPTION>\n");
    }
    select.append("</SELECT>\n");
    //System.out.println(select.toString());
    return select.toString();
  }
  public void setVariableValue(int v, String s) {
    theParty.setVariableValue(v, s);
  }
  public String getTemplateTitles(String attributes) {
    String [] titles = theParty.getTemplateTitles();
    StringBuffer select = new StringBuffer(100);
    select.append("<SELECT ");
    select.append(attributes);
    select.append(">\n");
    select.append("<OPTION VALUE='-1' SELECTED='1'>Choose a title</OPTION>\n");
    for (int i=0; i<titles.length; i++) {
      select.append("<OPTION VALUE='");
      select.append(i);
      select.append("'>");
      select.append(titles[i]);
      select.append("</OPTION>\n");
    }
    select.append("</SELECT>\n");
    //System.out.println(select.toString());
    return select.toString();
  }
  public String fillTemplate(int t) {
    return theParty.fillTemplate(t);
  }
}

